/* ------
Version de test du premier protocole de communication (sans les reset)
Il faut désactiver l'envoi des reset (254) pour que cela fonctionne correctement.

*/ 

import processing.serial.*; //librairie pour la lisaison série

Serial myPort;  // Instantiation du port série

// Définitions des variables graphiques : l'interface est un disque blanc sur lequel seront affichés les points détectés
int Taille =1000; // taille de la fenêtre en nb de pixels
int r_max=200; // rayon équivalent réel (en cm)

int RayonEllipse=Taille/2;
int CenterX=Taille/2;
int CenterY=Taille/2;

void setup() // idem setup Arduino : exécuté UNE seule fois au début (ou après reset)
{
   size(Taille, Taille);
   background(192, 64, 0);
   ellipse(CenterX, CenterY, RayonEllipse*2, RayonEllipse*2);
   //println(Serial.list()); // pour obtenir la liste des ports séries sur le PC
   // la solution la plus simple est de regarder sur quel est le bon port dans le logiciel Arduino
   
   //Voici les valeurs dans mon cas (Ubuntu 14.04) :
   // port arduino uno : /dev/ttyACM0
   // port arduino mini : /dev/ttyUSB0
   //String portName = Serial.list()[0]; // default - work for uno
  
   String portName = "/dev/ttyUSB0"; // mini
   myPort = new Serial(this, portName, 9600); // Ouverture de la liaison série sur le port choisi à le vitesse de 9600 bauds (standard)
}

void draw() // idem loop arduino : exécuté en continu après le setup 
{
  byte[] inBuffer = new byte[16]; // buffer d'entrée
  
  while ( myPort.available() > 0)
  {  
    myPort.readBytesUntil(255,inBuffer); // on place les valeurs dans le buffer jusqu'au flag de fin (255)
    if(inBuffer[0]+256==250) // ne pas oublier que les nombres sont codés en CA2 sur la liaison série (unsigned byte)
    {
      int angleTemp = inBuffer[2];
      if(angleTemp < 0){ angleTemp += 256; }// idem
       
      float angle = inBuffer[1]*256 + angleTemp; // pas de soucis pour inBuffer[1] qui vaut 0 ou 1
      float distance = inBuffer[3];
      if(distance < 0){distance+=256;} // idem
      affPoint(angle, distance);

    }
  } 
}


void affPoint(float angle, float distance) // fonction d'affichage dans l'interface garphique
{
  float norm=distance/r_max*RayonEllipse; // remise à l'echelle

  float x=CenterX+norm*cos(angle/360*2*PI);  //calcul des coordonnées carthésiennes à partir des coordonnées polaires
  float y=CenterY+norm*sin(angle/360*2*PI);
  print(angle); // affichage console
  print(" - ");
  println(distance);
  crossPoint(x,y); // appel à la sous-fonction d'affichage graphique
  
}

void crossPoint(float x, float y) // sous-fonction d'affichage : tracé d'une croix
{
  line(x-3,y,x+3,y);
  line(x,y-3,x,y+3);  
}

